program gea;
{E.H.Dooijes / based on Koeckhoven/Spanhoff assignment ca. 1984 }

uses Dos,Crt,GritN,cmstuf;

const
   maxTEKENEN = 400;
       GnaarR =  0.0174532925;
       RnaarG = 57.29577951;
          TOL =  1e-5;

type realdata = array[1..100] of real;
     punt3 = record x,y,z: real end;
     punt3array = array[1..200] of punt3;
     goniotype = record  sinus, cosinus: real  end;
     scholtype = array[1..50] of record fnaam: string end;

var
  keuze, xS, xS1, xS2: integer;
                  i,j: integer;
                 knop: integer;
                  ade: byte;
                  x,y: real;
                   ok: boolean;
                m1,m2: integer;
               nschol: integer;
               schaal: real;
              middenX: real;
              middenY: real;
       psiMid, phiMid: real;
     gPsiMid, gPhiMid: goniotype;
                schol: scholtype;
                    q: string;

{$I globals1.p}

procedure initialiseer;
var
    i: integer;
    naam:  array[1..16] of string;
begin
    naam[1]:=  'afrika.org';   {Afrika}
    naam[2]:=  'zuidp.org' ;   {Antarktika}
    naam[3]:=  'aus.org'   ;   {Australie}
    naam[4]:=  'borneo.org';   {Borneo}
    naam[5]:=  'eurazie.org';  {Europa-Azie}
    naam[6]:=  'gbrit.org';    {Groot-Brittannie}
    naam[7]:=  'groenl.org';   {Groenland}
    naam[8]:=  'japan.org';    {Japan}
    naam[9]:=  'madag.org';    {Madagaskar}
    naam[10]:= 'newg.org';     {Nieuw-Guinea}
    naam[11]:= 'newz.org';     {Nieuw-Zeeland}
    naam[12]:= 'noordam.org';  {Noord-Amerika}
    naam[13]:= 'sumat.org';    {Sumatra}
    naam[14]:= 'tasman.org';   {Tasmanie}
    naam[15]:= 'ijsland.org';  {IJsland}
    naam[16]:= 'zuidam.org';   {Zuid-Amerika}
    for i:=1 to 16 do naam[i]:='orgs\'+naam[i];
    for i:=1 to 16 do schol[i].fnaam:= naam[i];
end;    { initialiseer }


procedure leesMidden;
var
     ade: integer;
    x, y: integer;
begin
    SetViewport(0.05,0.09375, 0.95,0.65625, white);
    SetWindow(-180,-90, 180,90);
    DrawLine( -180, 0, 180, 0, lightred);
    DrawLine( 0, -90, 0, 90, lightred);
    GraphText( -80, 65, 'latitude North', red);
    GraphText( -80,-70, 'latitude South',red);
    GraphText( -160, 20, 'longitude West',red);
    GraphText( 100, 20, 'longitude East',red);
    for x:=-18 to 18 do
      DrawLine(x*10,-5,x*10,5,red);
    for x:=-5 to 5 do
     begin
      DrawLine(x*30,-5,x*30,5,lightred);
      if x<>0 then
        GraphText(x*30-5,-10,inttostring(x*30),red);
     end;
    for y:=-9 to 9 do
      DrawLine(-5,y*10,5,y*10,red);
    for y:=-4 to 4 do
     begin
      DrawLine(-5,y*20,5,y*20,lightred);
      if y<>0 then
        GraphText(10,y*20,inttostring(y*20),red);
     end;
    Marker(5,52.5,plus,lightmagenta);
    GraphText(6,53,'Amsterdam',magenta);
    Prompt('Click the point that will become the centre of the projection');
    Locator( phiMid, psiMid, ade);
{
    phiMid:= 10*round(phiMid/10);
    psiMid:= 10*round(psiMid/10);
}
    if abs(psiMid)<TOL then psiMid:= TOL;
    phiMid:= GnaarR*phiMid;  maakGonio( phiMid, gPhiMid);
    psiMid:= GnaarR*psiMid;  maakGonio( psiMid, gPsiMid);
    Prompt('');
    RemoveViewport
end;    {leesMidden}

procedure cirkelDeel(mx,my, p1x,p1y, p2x,p2y, beta1,beta2: real; col:integer);
{ Tekent een deel van een ellips (geprojekteerde 3D-cirkel).    }
{ Het middelpunt is  m  en de cirkel gaat door  p1  en  p2.     }
{ p1  en  p2  liggen 1/4 omtrek van elkaar.                     }
{ Dus  p1-m  en  p2-m  staan loodrecht op elkaar.               }
{ Elk punt van de ellips korrespondeert met een hoek beta,      }
{ 0 <= beta < 2*PI;         bij p1 geldt:  beta = 0;            }
{                           bij p2 geldt:  beta = PI/2.         }
var
           x,y: array[1..100] of real;
      nStappen: integer;
             i: integer;
 beta, s, c, k: real;

begin
    if beta2 < beta1 then exit;
    nStappen:= round( RnaarG*(beta2-beta1)/4 ) + 1;
    k:= (beta2-beta1)/nStappen;
    for i:= 0 to nStappen do begin
        beta:= beta1+ k*i;
        s:= sin(beta);
        c:= cos(beta);
        x[i+1]:= c*(p1x-mx) + s*(p2x-mx) + mx;
        y[i+1]:= c*(p1y-my) + s*(p2y-my) + my
    end;
    Polyline(@x,@y,nStappen+1,col,nonclosed)
end;    { cirkelDeel }

procedure tekenWereld;
{ tekent breedtecirkels en meridianen;          }
{ nLijnen = het aantal lijnen per 1/4 omtrek.   }
const nLijnen = 9;
var
          phi, psi: real;
poolrand, poolbeta: real;
           beta, x: real;
            col, i: integer;

begin
    SetViewport(0,0, 1,0.75, white);
    SetWindow(-1.4,-1.05, 1.4,1.05);
    poolrand:= 10*GnaarR;   { tussen de pool en de breedtecirkel poolrand }
                            { worden geen meridianen getekend, omdat ze   }
                            { daar veel te dicht op elkaar liggen.        }

    cirkelDeel( 0,0, 1,0, 0,1, 0, 2*PI,lightblue);

    for i:= -nLijnen+1 to nLijnen-1 do begin        { breedtecirkels }
      if i=0 then col:=lightcyan else col:=lightblue;
      psi:= i*PI/(2*nLijnen);
        x:= tan(psiMid)*tan(psi);
        if x >= -1 then begin  { breedtecirkel is zichtbaar }
            if x > 1 then beta:=0  { breedtecirkel is helemaal zichtbaar }
            else beta:= arccos(x);
            cirkelDeel( 0,sin(psi)*cos(psiMid), 0,sin(psi+psiMid),
                        cos(psi),sin(psi)*cos(psiMid),
                        beta, 2*PI-beta, col)
        end
    end;
    for i:= -3*nLijnen+1 to 3*nLijnen do begin          { meridianen }
      if i=0 then col:=lightcyan
       else if i=2*nlijnen then col:=cyan
       else col:=lightblue;
      phi:= i*PI/(2*nLijnen)-phiMid;
      if (phi>-PI/2) and (phi<PI/2) then
       begin
        beta:= PI/2 + arctan( cos(phi)*cos(psiMid)/sin(psiMid) );
        poolbeta:= poolrand;
        if psiMid < 0 then begin
            beta:= beta + PI;
            poolbeta:= poolbeta - PI
        end;
        if abs(psiMid) < poolrand then
            cirkelDeel( 0,0, 0,cos(psiMid), sin(phi),-sin(psiMid)*cos(phi),
                        poolrand, PI-poolrand, col)
        else begin
            cirkelDeel( 0,0, 0,cos(psiMid), sin(phi),-sin(psiMid)*cos(phi),
                        beta-PI, -poolbeta, col);
            cirkelDeel( 0,0, 0,cos(psiMid), sin(phi),-sin(psiMid)*cos(phi),
                        -poolbeta+2*poolrand, beta, col)
        end
       end
    end
end;    { tekenWereld }

procedure tekenSchol(ischol, kleur, rand: integer );
var
    lijn: array[1..100] of record
                               index1, index2: integer;
                               hoek1, hoek2: real;
                               gebruikt: boolean
                           end;
      i, j, n, i0, i1: integer;
      vul, ind1, ind2: integer;
      nStappen, nLijn: integer;
 aantal, start, delta: integer;
   alfa, alfa1, alfa2: real;
  k, phi, psi, x1, y1: real;
                    F: text;
                    p: punt3;
           tx, ty, tz: array[1..maxTekenen] of real;
             tfx, tfy: array[1..maxTekenen] of real;
               ncoord: integer;

function rechtsOpvolger(i0: integer): integer;
var
                  i, imin: integer;
    mindelta, alfa, delta: real;
begin
    alfa:= lijn[i0].hoek2;
    imin:= i0;
    mindelta:= 2*PI + 1;
    for i:= 1 to nLijn do
        if not lijn[i].gebruikt then begin
            delta:= lijn[i].hoek1 - alfa;
            if delta<0 then delta:= delta + 2*PI;
            if delta<mindelta then begin
                mindelta:= delta; imin:=i
            end
        end;
    rechtsOpvolger:= imin
end;    { rechtsOpvolger }


begin
    assign(F,schol[ischol].fnaam);
    reset(F);
    readln(f,ncoord);
    for n:=1 to ncoord do
     begin
        readln(F, phi, psi);
        BOLnaarXYZ(phi, psi, p);  aardePuntMee(p);
        tx[n]:= p.x;
        ty[n]:= p.y;
        tz[n]:= p.z
    end;
    tx[n+1]:=tx[1];     ty[n+1]:=ty[1];     tz[n+1]:=tz[1];
    i:=0;
    repeat i:= i+1 until (tz[i]<0) or (i=n+1);    { eerste onzichtbare punt }
    if i<>n+1 then begin        { niet alle punten zijn zichtbaar }
        nLijn:= 0;
        for j:= 1 to n do begin
            if (tz[i]<0) and (tz[i+1]>=0) then begin
                { i+1: eerste punt van een zichtbare lijn }
                nLijn:= nLijn+1;
                lijn[nLijn].index1:=i+1;
                lijn[nLijn].hoek1:= arctan2( tx[i+1], ty[i+1]);
                lijn[nLijn].gebruikt:= false
            end
            else if (tz[i]>=0) and (tz[i+1]<0) then begin
                { i: laatste punt van een zichtbare lijn }
                lijn[nLijn].index2:=i;
                lijn[nLijn].hoek2:= arctan2( tx[i], ty[i]);
            end;
            i:= i+1;
            if i=n+1 then i:=1
        end;
        if nLijn>0 then begin     { er zijn zichtbare lijnen }
            aantal:=0;
            while  aantal<nLijn  do begin
                start:= 1;
                vul:= 1;
                while lijn[start].gebruikt do start:= start+1;
                i0:= start;
                repeat
                    { zichtbare lijn  &  een boog in fx en fy zetten }
                    i1:= rechtsOpvolger(i0);
                    ind1:= lijn[i0].index1;
                    ind2:= lijn[i0].index2;
                    delta:= ind1-vul;
                    if ind1>ind2 then ind1:=ind1-n;
                    for i:= vul to vul + ind2 - ind1 do begin
                        if i+delta = n+1 then delta:= delta-n;
                        tfx[i]:= tx[i+delta];
                        tfy[i]:= ty[i+delta]
                    end;
                    vul:= vul + ind2 - ind1 + 1;
                    alfa1:= lijn[i0].hoek2;
                    alfa2:= lijn[i1].hoek1;
                    if alfa2<alfa1 then alfa2:= alfa2+2*PI;
                    nStappen:= round( RnaarG*(alfa2-alfa1)/4) + 1;
                    k:= (alfa2-alfa1)/nStappen;
                    for i:= 0 to nStappen do begin
                        alfa:= alfa1 + k*i;
                        tfx[vul]:= sin(alfa);
                        tfy[vul]:= cos(alfa);
                        vul:= vul+1
                    end;
                    lijn[i1].gebruikt:= true;
                    i0:= i1;
                    aantal:= aantal +1
                until  i1 = start;
                FillArea(@tfx, @tfy, vul-1, lightgreen)
            end
        end
    (*    else
           begin
               Prompt('dit continent ligt op de achterkant van de aarde');
           end  *)
    end
    else FillArea(@tx, @ty, n, lightgreen);
    close(F)
end;    { tekenSchol }
begin
    hello('Program 2', 'Globe-projections', 'uk');
    SetUpGraphics;
    repeat
       leesMidden;
       tekenWereld;
       initialiseer;
       middenX:= 0;
       middenY:= 0;
       schaal:=1;
       for i:= 1 to 16 do tekenSchol(i,60,3);
       marker(0,0,plus,lightred);
       Prompt('Left-click to continue, right click to stop');
       Wait(-2,ade);
       RemoveViewport;
    until ade=2;
    DoneGraphics
end.
