program Opgave;
(*$M 65520,0,655360*)
uses Crt,Dos,GritN,cmstuf;


const HoofdKeuze:ButtTxtArr=('add|draw','load|sample','erase|drawing','','','','','STOP');
      TekenKeuze:ButtTxtArr=('choose|colour','make|blob','','erase|blob','','','','BACK');

      links =1;
      rechts=2;
      xlo=1; ylo=2;
      xrb=3; yrb=4;
      bigreal=1E10;

type vertexPtr  =^vertexNode;
     vertexNode = record x,y :real; next: vertexPtr end;
     naamstr =  string[25]; {voor compatibiliteit met MW datafiles}
     polygPtr  =  ^polygNode;
     polygNode =  record
                     vertex: vertexPtr;
                     xmin,ymin,xmax,ymax: real;
                     kleur,n,ref: integer;
                     naam: naamstr; pickb,tkn: boolean; {voor comp met MW data}
                     next: polygPtr
                  end;

     vertexFile = file of vertexNode;
     polygFile =  file of polygNode;
     window    =  array[1..4] of real;

var   PaletID,LeiID        :integer;
      Tekening             :polygPtr;
      knop,keuze,kleur     :integer;
      Lei                  :window;
      xlei,ylei            :real;

      _i:integer;
      _b:boolean;
      _t:polygPtr;

const Lei0:window=(0,0,100,100);


procedure Centreer;
begin
 xlei:=(Lei[xlo]+Lei[xrb])/2;
 ylei:=(Lei[ylo]+Lei[yrb])/2
end;


procedure SetLeiWindow;
begin
 SetWindow(Lei[xlo],Lei[ylo],Lei[xrb],Lei[yrb]);
 ClearViewport
end;


procedure SetLei0Window;
begin
 Lei:=Lei0;
 _b:=UseView(LeiID);
 SetLeiWindow;
 _i:=StoreView(LeiID);
 Centreer
end;

procedure MaakLei;
begin
 SetViewport(0.2,0.1,1.0,0.7,White);
 Lei:=Lei0;
 SetLeiWindow;
 LeiID:=StoreView(0);
 Centreer
end;

procedure RandRechthoek(x1,y1,x2,y2: real; klr: integer);
var PX,PY:array[1..4]of real;
begin
 PX[1]:=X1; PX[2]:=X1; PX[3]:=X2; PX[4]:=X2;
 PY[1]:=Y1; PY[2]:=Y2; PY[3]:=Y2; PY[4]:=Y1;
 PolyLine(addr(PX),addr(PY),4,klr,closed)
end;

procedure MaakPalet;
var klrX,klrY:integer;

  procedure VulRechthoek(X1,Y1,X2,Y2:real;klr:integer);
  var PX,PY:array[1..4]of real;
  begin
   PX[1]:=X1; PX[2]:=X1; PX[3]:=X2; PX[4]:=X2;
   PY[1]:=Y1; PY[2]:=Y2; PY[3]:=Y2; PY[4]:=Y1;
   FillArea(addr(PX),addr(PY),4,klr);
   PolyLine(addr(PX),addr(PY),4,DarkGray,closed)
  end;

begin {MaakPalet}
 SetViewport(0.02,0.3,0.12,0.7,Black);
 SetWindow(0,0,2,8);
 PaletID:=StoreView(0);
 for klrX:=0 to 1 do
  for klrY:=0 to 7 do
   VulRechthoek(klrX+0.05,klrY+0.05,klrX+0.95,klrY+0.95,8*klrX+klrY);
 klrX:=Kleur div 8;
 klrY:=Kleur mod 8;
 RandRechthoek(klrX,klrY,klrX+1,klrY+1,White);
end;

procedure KiesKleur(var Kleur:integer);
var klrX,klrY,X,Y:real;
begin
 _b:=UseView(PaletID);
 klrX:=Kleur div 8;
 klrY:=Kleur mod 8;
 RandRechthoek(klrX,klrY,klrX+1,klrY+1,Black);
 Locator(X,Y,Knop);
 klrX:=trunc(X);
 klrY:=trunc(Y);
 Kleur:=round(8*klrX+klrY);
 RandRechthoek(klrX,klrY,klrX+1,klrY+1,White)
end;

procedure VulPolyg(tkng: polygPtr);
var PX,PY: array[1..200] of real;
    i:integer;

  procedure MaakPX_PY(pnt: vertexPtr; n:integer);
  begin
   if n>0
    then with pnt^ do
     begin
      PX[n]:=x;
      PY[n]:=y;
      MaakPX_PY(next,n-1)
     end
  end;

begin {VulPolyg}
 if tkng<>nil
  then with tkng^ do
   begin
    MaakPX_PY(vertex,n);
    PolyLine(addr(PX),addr(PY),n,kleur,closed);
    FillArea(addr(PX),addr(PY),n,kleur)
   end
end;

procedure LoadTekening(var tkng: polygPtr);
var tek: polygFile;
    vlh: vertexFile;
    filename: string;

  procedure LoadTekening_1(var tkng: polygPtr);

    procedure LoadPolyg(var vertex,pred: vertexPtr; n:integer);
    begin
     if n<=0 then vertex:=pred
             else
               begin
                new(vertex);
                read(vlh,vertex^);
                LoadPolyg(vertex^.next,pred,n-1)
               end
    end;

  begin {LoadTekening_1}
   if eof(tek) then tkng:=nil
   else if tkng<>nil then LoadTekening_1(tkng^.next)
   else
      begin
        new(tkng);
        read(tek,tkng^);
        tkng^.next:=nil;
        LoadPolyg(tkng^.vertex,tkng^.vertex,tkng^.n);
        LoadTekening_1(tkng^.next)
      end
  end;

begin {LoadTekening}
   filename:='huis';
   assign(tek,'spts\'+filename +'.tek'); reset(tek);
   assign(vlh,'spts\'+filename +'.vlh'); reset(vlh);
   LoadTekening_1(tkng);
   close(vlh); close(tek)
end;


procedure maakTekening(var tkng: polygPtr; kleur:integer);
var vertex: vertexPtr;
    xmin,ymin,xmax,ymax,xpre,ypre: real;
    n: integer;

  procedure maakTekening_1(var tkng: polygPtr);

    procedure maakPolyg(var vertex,pred: vertexPtr);
    begin
     Locator(xlei,ylei,knop);
     if knop=rechts then vertex:=pred
     else
       begin
         if N=0 then Marker(Xlei,Ylei,pixel,kleur)
                else DrawLine(Xpre,Ypre,Xlei,Ylei,Kleur);
         if (N>0) and (Xlei=Xpre) and (Ylei=Ypre)
                then maakPolyg(vertex,pred)
                else
                   begin
                     new(vertex);
                     vertex^.x:=xlei;
                     vertex^.y:=ylei;
                     n:=n+1;
                     if xlei<xmin then xmin:=xlei;
                     if xlei>xmax then xmax:=xlei;
                     if ylei<ymin then ymin:=ylei;
                     if ylei>ymax then ymax:=ylei;
                     xpre:=xlei;
                     ypre:=ylei;
                     maakPolyg(vertex^.next,pred)
                   end
       end
    end;

  begin {MaakTekening_1}
   n:=0;
   vertex:=nil;
   xmin:=+bigreal; ymin:=+bigreal;
   xmax:=-bigreal; ymax:=-bigreal;
   maakPolyg(vertex,vertex);
   if n<=0
    then tkng:=nil
    else
     begin
      new(tkng);
      tkng^.vertex:=vertex;
      tkng^.xmin :=xmin;   tkng^.ymin :=ymin;
      tkng^.xmax :=xmax;   tkng^.ymax :=ymax;
      tkng^.kleur:=kleur;
      tkng^.n    :=n;
      VulPolyg(tkng);
      maakTekening_1(tkng^.next)
     end
  end;

begin {MaakTekening}
 Prompt('Left-click points. If done, right-click.');
 if tkng<>nil then maakTekening(tkng^.next,kleur)
              else
                begin
                   _b:=UseView(LeiID);
                   maakTekening_1(tkng)
                end;
 Prompt('')
end;

procedure Redraw(tkng:polygPtr; view:integer);

  procedure Redraw_1(tkng:polygPtr);
  begin
   if tkng<>nil
    then with tkng^ do
     begin
       VulPolyg(tkng);
       Redraw_1(Next)
     end
  end;

begin {Redraw}
 _b:=UseView(View);
 SetLeiWindow;
 ClearViewport;
 Redraw_1(tkng)
end;

procedure DelVertices(var vertex: vertexPtr; n:integer);
{heette eerst WegVeelhoek}
begin
 if n>0
  then
   begin
    DelVertices(vertex^.next,n-1);
    dispose(vertex);
    vertex:=nil
   end
end;

procedure DelPolyg(var tkng,polyg: polygPtr);
{heette eerst VerwijderVeelhoek}
var prev,next: polygPtr;
begin
 if polyg<>nil then
      begin
       DelVertices(polyg^.vertex,polyg^.n);
       if tkng=polyg then tkng:=tkng^.next
                     else
                       begin
                         next:=polyg^.next;
                         prev:=tkng;
                         while prev^.next<>polyg do prev:=prev^.next;
                         prev^.next:=next
                       end;
       dispose(polyg);
       polyg:=nil
   end
end;

procedure IdentPolyg(xx,yy:real; tkng,tot_tkng: polygPtr;
                       var picked: polygPtr);

  function OpRand(xx,yy:real; picked: vertexptr; n:integer): boolean;

    function OpRand_1(picked: vertexPtr; xpre,ypre: real; n:integer): boolean;
    var xcur,ycur: real;
    begin
     xcur:=picked^.x;
     Ycur:=picked^.y;
     if n<=0 then OpRand_1:=false
     else if xcur=xx then if (xpre=xx) or (ycur=yy) then OpRand_1:=true
     else OpRand_1:=OpRand_1(picked^.next,xcur,ycur,n-1)
     else if (ycur=yy) and (ypre=yy) then OpRand_1:=true
     else OpRand_1:=OpRand_1(picked^.next,xcur,ycur,n-1)
    end;

  begin {OpRand}
   with picked^ do
    OpRand:=OpRand_1(next,x,y,n)
  end;

  function Snijpunten(xx,yy:real; picked: vertexPtr; n:integer): integer;

    function Snijdt(x1,y1,x2,y2:real): boolean;
    begin
     Snijdt:=(x2-x1)/(y2-y1)*(y2-yy)<=x2-xx
    end;

    function Snijpunten_1(picked: vertexPtr;
                                     xref,yref: real; n:integer): integer;
    var xcur,ycur: real;
    begin
       xcur:=picked^.x;
       ycur:=picked^.y;
       if n<=0 then Snijpunten_1:=0
       else if ((yref<yy) and (ycur<yy))
            or ((yref>yy) and (ycur>yy))
            or ((xref<xx) and (xcur<xx))
       then Snijpunten_1:=Snijpunten_1(picked^.next,xcur,ycur,n-1)
       else if ycur=yy then
            if xcur<xx then
               Snijpunten_1:=Snijpunten_1(picked^.next,-bigreal,yref,n-1)
            else Snijpunten_1:=Snijpunten_1(picked^.next,+bigreal,yref,n-1)
            else if Snijdt(xref,yref,xcur,ycur)
            then Snijpunten_1:=Snijpunten_1(picked^.next,xcur,ycur,n-1)+1
            else Snijpunten_1:=Snijpunten_1(picked^.next,xcur,ycur,n-1)
    end;

  begin {Snijpunten}
   if picked=nil then Snijpunten:=0
   else
     begin
      while picked^.y=yy do picked:=picked^.next;
      with picked^ do Snijpunten:=Snijpunten_1(next,x,y,n)
     end
  end;

begin {IdentPolyg}
  if tkng=tot_tkng then picked:=nil
  else with tkng^ do
    begin
      IdentPolyg(xx,yy,next,tot_tkng,picked);
      if picked=nil then
         if (xx>=xmin) and (yy>=ymin) and (xx<=xmax) and (yy<=ymax) then
           if OpRand(xx,yy,vertex,n) then picked:=tkng
           else if odd(Snijpunten(xx,yy,vertex,n)) then picked:=tkng;
    end
end;

procedure PickPolyg(tkng: polygPtr; var picked: polygPtr);
begin
 _b:=UseView(LeiID);
 Prompt('Point at a blob');
 Locator(xlei,ylei,knop);
 Prompt('');
 IdentPolyg(xlei,ylei,tkng,nil,picked);    {heette eerst VindVeelhoek}
 if picked=nil then Prompt('No blob pointed at !!')
end;

procedure DelPickedPolyg(var tkng: polygPtr);  {voorheen WisVeelhoek}
var polyg,prev,next: polygPtr;
begin
   PickPolyg(tkng,polyg);
   if polyg<>nil then
     begin
     DelPolyg(tkng,polyg);
     Redraw(tkng,LeiID)   {was TekenTekening}
   end
end;


procedure TekenMenu;
var Keuze:integer;
begin
 repeat
  DefineButtons(TekenKeuze);
  _i:=ReadButton(Keuze);
  case Keuze of
   1:KiesKleur(Kleur);
   2:MaakTekening(tekening,kleur);
   4:DelPickedPolyg(tekening)
  end
 until Keuze=8;
 Prompt('')
end;

procedure DispPolyg(var polyg:vertexPtr; n:integer);
begin
 if n>0 then
   begin
      DispPolyg(polyg^.next,n-1);
    dispose(polyg);
    polyg:=nil
   end
end;

procedure DispTekening(var tkng: polygPtr);
{voorheen, in MW's Tekenpak: WegTekening}
begin
 if tkng<>nil then
   begin
      DispPolyg(tkng^.vertex,tkng^.n);
      DispTekening(tkng^.next);
    dispose(tkng);
    tkng:=nil
   end
end;

procedure HoofdMenu;
var Keuze:integer;
begin
 repeat
  DefineButtons(HoofdKeuze);
  _i:=ReadButton(Keuze);
  case keuze of
   1:TekenMenu;
   2:begin
        LoadTekening(Tekening);
        Redraw(Tekening,LeiID)
     end;
   3:begin
        DispTekening(Tekening);
        SetLei0Window
     end
  end
 until keuze=8;
end;


begin
 hello('Program 8',
  'Draw a computer graphics picture','uk');
 SetUpGraphics;
 Tekening:=nil;
 Kleur:=White;
 MaakPalet;
 MaakLei;
 HoofdMenu;
 DoneGraphics;
end.
