program bresenh;
uses Crt,Dos,GritN,cmstuf;
const vpixnum = 21; hpixnum = 28;
var i,j,ix1,iy1,ix2,iy2,kleur,knop: integer;
    x,y: array[1..4] of real;
    palet: array[1..4] of integer;
    ade: byte;
    uu,vv: real; {locator coordinates global to preserve last cursor pos}
label 10;

procedure plot(i,j: integer);
begin
      x[1]:=i-0.5;   y[1]:=j-0.5;
      x[2]:=i+0.5;   y[2]:=j-0.5;
      x[3]:=i+0.5;   y[3]:=j+0.5;
      x[4]:=i-0.5;   y[4]:=j+0.5;
      FillArea(@x,@y,4,kleur);
end;

procedure LocPlot(var ix,iy,button: integer);
var i: integer;
label 10,20;
begin
  Locator(uu,vv,button);
  ix:=round(uu);
  iy:=round(vv);
  if ix<0      then ix:=0;
  if ix>hpixnum then ix:=hpixnum;
  if iy<0      then iy:=0;
  if iy>vpixnum then iy:=vpixnum;
  plot(ix,iy)
end;

procedure bresenham(x1,y1,x2,y2: integer);
{from Rogers, Procedural Elements}
var i,dx,dy,e,s1,s2,x,y,temp: integer;
    swap: boolean;

function signum(x: integer): integer;
begin
   if x<0 then signum:=-1
          else begin if x>0 then signum:=1 else signum:=0 end
end;

begin
   x:=x1;
   y:=y1;
   dx:=abs(x2-x1);
   dy:=abs(y2-y1);
   s1:=signum(x2-x1);
   s2:=signum(y2-y1);
   if dy>dx then
      begin
         temp:=dx;
         dx:=dy;
         dy:=temp;
         swap:=true
      end
   else swap:=false;
   e:=2*dy-dx;
   for i:=1 to dx do
     begin
         plot(x,y);
         while e>=0 do
            begin
                if swap then x:=x+s1
                        else y:=y+s2;
                e:=e-2*dx
            end;
         if swap then y:=y+s2
                 else x:=x+s1;
         e:=e+2*dy
     end
end;

procedure schoonscherm;
var i: integer;
begin
    ClearViewport;
    for i:=0 to vpixnum+1 do DrawLine(-0.5,i-0.5,hpixnum+0.5,i-0.5,lightgray);
    for i:=0 to hpixnum+1 do DrawLine(i-0.5,-0.5,i-0.5,vpixnum+0.5,lightgray);
end;

begin {main}
    Hello('Program 1','Drawing an (almost) straight line','uk');
    SetUpGraphics;
    SetViewport(0.05,0.05, 0.85,0.65, lightgray);
    SetWindow(-0.5,-0.5,hpixnum+0.5,vpixnum+0.5);
    palet[1]:=lightgreen;
    palet[2]:=lightred;
    palet[3]:=yellow;
    palet[4]:=lightblue;

10: schoonscherm;
    j:=0;
    REPEAT
    j:=j+1;
    kleur:=palet[1+j mod 4];
    Prompt('Click starting pixel (right click for a clean window)');
    LocPlot(ix1,iy1,knop);
    if knop=2 then begin schoonscherm; plot(ix1,iy1) end;
    Prompt('Click end pixel');
    LocPlot(ix2,iy2,knop);
    Bresenham(ix1,iy1,ix2,iy2);
    Prompt('Left click to continue, right click to stop');
    Wait(-2,ade);
    UNTIL ade=2;
    if ade=1 then goto 10;
    DoneGraphics
end.


