{$N+}
program objtrans;
{programma door onbekende student, volledig herzien voor nemo dec 2007 / ehd}
uses crt,dos,gritn,cmstuf;

const
     NMAX=100;
     endpoints=50;
     left=1;right=2;
     v5xmin=0.25;v5ymin=0.1;v5xmax=0.75;v5ymax=0.6;
     w5xmin=0;w5ymin=0;w5xmax=100;w5ymax=100;
     v6xmin=0;v6ymin=0.65;v6xmax=1;v6ymax=0.7;
     w6xmin=0;w6ymin=0;w6xmax=10;w6ymax=10;
     pause=1;
     sigma=1.0;

TYPE
   realdata = ARRAY[1..NMAX] of REAL;

VAR
   dx,dy,x1,y1,x2,y2,xp,yp,xs1,ys1,xs2,ys2,xobj,yobj,xtemp,ytemp: realdata;
   s,t: REAL;
   ade: BYTE;
   xloc,yloc,cx,cy: REAL;
   dNobj,steps,i,j,n: integer;
   button,menu1button,menu2button,menu3button: integer;
   view1,view2,view3,view5: integer;
   ns1,ns2: INTEGER;
   ok,hold,vullen: BOOLEAN;
   text1,text2,text3: ButtTxtArr;
   kleur: integer;
   u,v: real;

{$I cline.p}

FUNCTION Centre(x: realdata; n: INTEGER): REAL;

VAR
   i: INTEGER;
   sum: REAL;

BEGIN {centre}
      sum:=0;
      for i:=1 to n do
        sum:=sum+x[i];
      sum:=sum/n;
      Centre:=sum;
END; {centre}

procedure linkerkromme;
label 10;
begin
10: Prompt('first keyframe: click a few points in the left window, right_click AFTER the last');
    ok:=UseView(view1);
    ClearViewport;
    ns1:=0;
    button:=left;
    u:=1000; v:=1000;
    while(button=left) do
      begin
        ns1:=ns1+1;
        Locator(u,v,button);
        x1[ns1]:=u; y1[ns1]:=v;
        if(button=left) then
          Marker(u,v,dot,lightgreen);
       end;
    ns1:=ns1-1;
    if ns1<3 then goto 10;
    kurvp1(ns1,x1,y1,sigma,xp,yp,s);
    for j:=1 to endpoints do
          kurvp2((j-1)/(endpoints-1),s,sigma,ns1,x1,y1,xp,yp,xs1[j],ys1[j]);
    Polyline(@xs1,@ys1,endpoints,yellow,nonclosed);
    Prompt('');
end;

procedure rechterkromme;
label 10;
begin
10: Prompt('make a second keyframe picture in the right window');
    ok:=UseView(view2);
    ClearViewport;
    ns2:=0;
    button:=left;
    u:=1000; v:=1000;
    while(button=left) do
      begin
        ns2:=ns2+1;
        Locator(u,v,button);
        x2[ns2]:=u; y2[ns2]:=v;
        if(button=left) then
          Marker(u,v,dot,lightgreen);
       end;
    ns2:=ns2-1;
    if ns2<3 then goto 10;
    kurvp1(ns2,x2,y2,sigma,xp,yp,s);
    for j:=1 to endpoints do
          kurvp2((j-1)/(endpoints-1),s,sigma,ns2,x2,y2,xp,yp,xs2[j],ys2[j]);
    Polyline(@xs2,@ys2,endpoints,yellow,nonclosed);
    Prompt('');
end;

procedure schuiven;
begin
   Prompt('keyframes standing apart');
   ok:=UseView(view3);
   ClearViewPort;
   text2[1]:='start';
   text2[2]:='5|steps';
   text2[3]:='10|steps';
   text2[4]:='30|steps';
   text2[5]:='100|steps';
   text2[6]:='colour|filled?';
   text2[7]:='';
   text2[8]:='main|menu';
   DefineButtons(text2);
   repeat
      button:=ReadButton(menu2button);
      case(menu2button) of
        1:
          begin
            Prompt('');
            ok:=UseView(view3);
            ClearViewPort;
            for i:=1 to endpoints do
              begin
                dx[i]:=xs2[i]-xs1[i];
                dy[i]:=ys2[i]-ys1[i];
              end;
            i:=0;
            kleur:=((i+1) mod 7)+8;
            if vullen then FillArea(@xs1,@ys1,endpoints,kleur)
            else Polyline(@xs1,@ys1,endpoints,kleur,closed);
            for i:=1 to steps-1 do
              begin
                for j:=1 to endpoints do
                  begin
                    xobj[j]:=xs1[j]+i/steps*dx[j];
                    yobj[j]:=ys1[j]+i/steps*dy[j];
                  end;
                kleur:=((i+1) mod 7)+8;
                if vullen then
                   FillArea(@xobj,@yobj,endpoints,kleur)
                else
                   Polyline(@xobj,@yobj,endpoints,kleur,closed);
              end;
            kleur:=((steps+1) mod 7)+8;
            if vullen then FillArea(@xs2,@ys2,endpoints,kleur)
            else Polyline(@xs2,@ys2,endpoints,kleur,closed);
          end;
        2:  steps:=5;
        3:  steps:=10;
        4:  steps:=30;
        5:  steps:=100;
        6: vullen:=not vullen;
      end;
   until menu2button=8;         {type 1 acties}
   DefineButtons(text1);       {terug naar hoofdmenu}
   ok:=UseView(view1);
   ClearViewPort;
   for i:=1 to ns1-1 do
     Marker(x1[i],y1[i],249,11);
   Polyline(@xs1,@ys1,endpoints,yellow,nonclosed);
   ok:=UseView(view2);
   ClearViewPort;
   for i:=1 to ns2-1 do
     Marker(x2[i],y2[i],249,13);
   Polyline(@xs2,@ys2,endpoints,yellow,nonclosed);
end;

procedure filmpje;
begin
   Prompt('keyframes and inbetweens in a single window');
   ok:=UseView(view3); {3 overlapt 1 en 2}
   RemoveViewport;
   ok:=UseView(view5);
   ClearViewPort;
   text3[1]:='start';
   text3[2]:='5|steps';
   text3[3]:='10|steps';
   text3[4]:='30|steps';
   text3[5]:='100|steps';
   text3[6]:='';
   text3[7]:='';
   text3[8]:='main|menu';
   DefineButtons(text3);
   repeat
       button:=ReadButton(menu3button);
       case(menu3button) of
         1:begin
             Prompt('');
             ClearViewPort;
             for i:=1 to endpoints do
               begin
                 dx[i]:=xs2[i]-xs1[i];
                 dy[i]:=ys2[i]-ys1[i];
               end;
             cx:=Centre(xs1,endpoints);
             cy:=Centre(ys1,endpoints);
             for j:=1 to endpoints do
               begin
                 xtemp[j]:=xs1[j]-cx+0.5*(w5xmax-w5xmin);  {##}
                 ytemp[j]:=ys1[j]-cy+0.5*(w5ymax-w5ymin);
               end;
             Polyline(@xtemp,@ytemp,endpoints,yellow,closed);
             Polyline(@xtemp,@ytemp,endpoints,0,closed);
             for i:=1 to steps-1 do
               begin
                 for j:=1 to endpoints do
                   begin
                     xobj[j]:=xs1[j]+i/steps*dx[j];
                     yobj[j]:=ys1[j]+i/steps*dy[j];
                   end;
                 cx:=Centre(xobj,endpoints);
                 cy:=Centre(yobj,endpoints);
                 for j:=1 to endpoints do
                   begin
                     xobj[j]:=xobj[j]-cx+0.5*(w5xmax-w5xmin); {##}
                     yobj[j]:=yobj[j]-cy+0.5*(w5ymax-w5ymin);
                   end;
                 Polyline(@xobj,@yobj,endpoints,yellow,closed);
                 wait(0.5,ade);
                 Polyline(@xobj,@yobj,endpoints,0,closed);
               end;
             cx:=Centre(xs2,endpoints);
             cy:=Centre(ys2,endpoints);
             for j:=1 to endpoints do
               begin
                 xtemp[j]:=xs2[j]-cx+0.5*(w5xmax-w5xmin);  {##}
                 ytemp[j]:=ys2[j]-cy+0.5*(w5ymax-w5ymin);
               end;
             Polyline(@xtemp,@ytemp,endpoints,yellow,closed);
           end;
         2:  steps:=5;
         3:  steps:=10;
         4:  steps:=30;
         5:  steps:=100;
       end
   until menu3button=8;
   DefineButtons(text1);   {terug naar hoofdmenu}
   ok:=UseView(view1);
   ClearViewPort;
   for i:=1 to ns1-1 do Marker(x1[i],y1[i],249,11);
   Polyline(@xs1,@ys1,endpoints,yellow,nonclosed);
   ok:=UseView(view2);
   ClearViewPort;
   for i:=1 to ns2-1 do Marker(x2[i],y2[i],249,13);
   Polyline(@xs2,@ys2,endpoints,yellow,nonclosed);
end;

BEGIN {main}
      hello('Programma 4', 'Inbetweening','uk');
      SetUpGraphics;
      SetViewport(0.0,0.1, 1.0,0.6, 14);
      SetWindow(0,0, 200,100);
      view3:=StoreView(0);

      SetViewport(v5xmin,v5ymin,v5xmax,v5ymax,14);
      view5:=StoreView(0);

      SetViewport(0.0,0.1, 0.5,0.6, 14);
      SetWindow(0,0, 100,100);
      view1:=StoreView(0);

      ClearViewport;

      SetViewport(0.5,0.1, 1.0,0.6, 14);
      SetWindow(100,0, 200,100);
      view2:=StoreView(0);

      ClearViewport;
      Prompt('In-betweening of closed curves');

      text1[1]:='first|frame';
      text1[2]:='final|frame';
      text1[3]:='';
      text1[5]:='film';
      text1[4]:='moving|l-to-r';
      text1[6]:='';
      text1[7]:='';
      text1[8]:='stop';
      dNobj:=1;
      steps:=10;
      hold:=FALSE;
      ns1:=0;ns2:=0;

      REPEAT {hoofmenu}
      vullen:=false;
      DefineButtons(text1);
      button:=ReadButton(menu1button);
      case(menu1button) of
        1: linkerkromme;
        2: rechterkromme;
        4: schuiven;
        5: filmpje;
      end {hoofdmenu cases}
      until menu1button=8;
      DoneGraphics;
END.
